#ifndef __COMMON
#define __COMMON

// possible variable types for shared variables and arrays
#define IVAR 1
#define FVAR 2
#define DVAR 3

/* possible combine strategies for combineitems */
#define ADD 1
#define MULT 2
#define AND 4
#define OR 8
#define FUNC 16
#define LEADER 32
#define UPDATED 64

// determines the maximum amount of combineitems in a message
#define MAX_COMBINE_ITEMS 64

// default buffer size for bsends
#define BBUFFERSIZE 200000000

// various return values
#define ATTACH_ERROR -1
#define ATTACH_SUCCESS 0

#define RECEIVE_ERROR -1
#define RECEIVE_SUCCESS 0

#define MERGE_ERROR -1
#define MERGE_SUCCESS 0

#define READ_REQUEST_ERROR -1
#define READ_REQUEST_SUCCESS 0

#define WRITE_REQUEST_ERROR -1
#define WRITE_REQUEST_SUCCESS 0

#define REGISTER_ERROR -1
#define REGISTER_SUCCESS 0

#define SCATTER_ERROR -1
#define SCATTER_SUCCESS 0

#define GATHER_ERROR -1
#define GATHER_SUCCESS 0

#define PACK_ERROR -1
#define PACK_SUCCESS 0
#define RECOMMENDED_AMOUNT_EXCEEDED 1

#define REQ_ERROR -1
#define REQ_SUCCESS 0

#define UNPACK_ERROR -1
#define UNPACK_SUCCESS 0

#define CREATE_TYPE_ERROR -1
#define CREATE_TYPE_SUCCESS 0

#define IMPORT_ERROR -1
#define IMPORT_SUCCESS 0

#define EXPORT_ERROR -1
#define EXPORT_SUCCESS 0

#define MAX_DATA 200000000
#define RECOMMENDED_AMOUNT 80000000

// prefix tags
#define NO_PREFIX 1
#define PREFIX 2
#define UPDATE 4

// updated tags, share same space as prefix_tag
#define NOT_UPDATED 8
//#define UPDATED 16 // defined elsewhere to 64, ok for now

#define MAX_DEPTH 10

typedef struct name {
	int procedure;
	int relative;
	int path[MAX_DEPTH];
} Name;

#endif
